<?php namespace Avans\api;

use Avans\avans;
use Avans\data;
use Avans\func;
use Avans\user;
use WP_REST_Request;

class api{


    public function __construct()
    {
        add_action('rest_api_init', array($this,'avans_rest_api'));
    }

    public function avans_rest_api(){
        $this->create_route('settings','get_settings');
        $this->create_route('users', 'get_users');
        $this->create_route('log/add', 'add_log', 'POST');
    }

    public function create_route($namespace,$callback,$method = 'GET'){
        register_rest_route('avans/v1', "/$namespace", array(
            'methods' => $method,
            'callback' => array($this,$callback),
            'permission_callback' => '__return_true',
        ));
    }
    

    public function get_settings(){
        $this->check_permision();
        $settings = AVANS_SETTINGS;
        wp_send_json($settings);
    }
    
    public function get_users(WP_REST_Request $request){
        $args = [];

        if (func::is_set($request['type'])) {
            $args['type'] = $request['type'];
            $args['where'] = true;
        }

        if (func::is_set($request['user'])) {
            $args['user'] = $request['user'];
            $args['where'] = true;
        }

        if (func::is_set($request['from'])) {
            $args['time']['from'] = func::convert_jalali_to_miladi($request['from']);
            $args['where'] = true;
        }

        if (func::is_set($request['to'])) {
            $args['time']['to'] = func::convert_jalali_to_miladi($request['to']);
            $args['where'] = true;
        }
        
        if (func::is_set($request['page'])) {
            $args['page'] = $request['page'];
        }

        if (func::is_set($request['per_page'])) {
            $args['per_page'] = $request['per_page'];
        }

        $users = data::get_users($args);
        wp_send_json($users);
    }


    public function add_log(WP_REST_Request $request){

        if(!isset($request['user_id']) || (int)$request['user_id'] <= 0){
            wp_send_json([
                'messege' => "'user_id' property is not set",
                'data' => [
                    'status' => 400,
                ]
            ], 400);
        }

        if(!isset($request['type'])){
            wp_send_json([
                'messege' => "'type' property is not set",
                'data' => [
                    'status' => 400,
                ]
            ], 400);
        }

        $result = $this->check_data_for_add_log( $request );

        wp_send_json([
            'messege' => $result['msg'],
            'data' => [
                'status' => $result['status'],
            ]
        ], $result['status']);


    }


    public function check_data_for_add_log($request){

        $user_id = $request['user_id'];
        $type = $request['type'];
        $score = $request['score'];
        $object = $request['object'];

        switch($type){

        }
        
    }

    public function check_permision(){
        if (!current_user_can('administrator')) {
            wp_send_json([
                'messege' => "You don't have permission to access!",
                'data' => [
                    'status' => 403,
                ]
            ], 403);
        }
    }

}