<?php namespace Avans\parts;

use DrClubs\callback;
use DrClubs\rest;

class convert{
 
    public static function wallet_transaction($user_id,$amount,$derscription){
        $res = false;
        $settings = AVANS_SETTINGS['general_settings']['wallet'];

        
        if ((int)$amount == 0) {
            return false;
        }

        
        if (defined('YITH_FUNDS_FILE')) {
            if (!class_exists('YITH_Funds')) {
                include_once(dirname(YITH_FUNDS_FILE) . '/class.yith-funds.php');
            }
        }

        if (defined('FSWW_FILE')) {
            if (!class_exists('Wallet')) {
                include_once(dirname(FSWW_FILE) . '/includes/classes/Wallet.php');
            }
        }

        switch (true) {
            case (class_exists('MLM_Nav_Menu_Walker')):
                $res = self::credit_mlm_wallet($user_id,$amount,$derscription);
            break;
            case (class_exists('Wallet')):
                $res = self::credit_fs_wallet($user_id,$amount);
            break;
            case (class_exists('YITH_Funds')):
                $res = self::credit_yith_wallet($user_id,$amount,$derscription);
            break;
            case (class_exists('WooWallet')):
                $res = self::credit_woo_wallet($user_id,$amount,$derscription);
            break;
            case (class_exists('\DrClubs\main')):
                $res = self::credit_drClubs_Wallet($user_id,$amount,$derscription);
            break;
            case ($settings['wallet_plugin'] == 'custom'):
                $res = apply_filters('avans_custom_convert_to_wallet',$res,$user_id,$amount,$derscription);
            break;
        } 
        return $res;
    }

    public static function credit_drClubs_Wallet($user_id,$amount,$derscription){
        callback::log(json_encode([$user_id,$amount,$derscription]));
        $data = get_option('avans_integration_DrClubs_settings',[]);
        $customerID = get_user_meta($user_id,'drclub_customerId',true);

        $api = new rest;
        $user = $data['username'];
        $pass = $data['password'];
        $login = $api->login($user,$pass);

        $data = array(
            'CustomerId' => $customerID,
            'Amount' => $amount,
            'Description' => $derscription,
	    );

        $res = $api->addBalance($data);
        return $res;
    }

    public static function credit_woo_wallet($user_id,$amount,$derscription){
        $convert= woo_wallet()->wallet->credit($user_id, $amount, $derscription);
        return $convert;
    }

    public static function credit_yith_wallet($user_id,$amount,$derscription){
        $fund_user = new \YITH_YWF_Customer($user_id);
        $old_funds = $fund_user->get_funds();
        $new_funds = $old_funds + intval($amount);
        $fund_user->set_funds($new_funds);

        $log_args = array( 'user_id' => $user_id, 'type_operation' => 'admin_op', 'fund_user' => $amount, 'description' => $derscription );

        $email_args = array(
            'user_id' => $user_id,
            'log_date' => date(wc_date_format(), current_time('timestamp')),
            'before_funds' => $old_funds,
            'after_funds' => $new_funds,
            'change_reason' => $derscription
        );

        WC()->mailer();
        do_action('ywf_send_advise_user_fund_email_notification', $email_args);
        YWF_Log()->add_log($log_args);
        return true;
    }

    public static function credit_fs_wallet($user_id,$amount){
        \Wallet::add_funds($user_id, $amount, 0);
        return true;
    }

    public static function credit_mlm_wallet($user_id,$amount,$derscription){
        $convert = mlmFire()->wallet->update_meta($user_id, 'mlm_balance', $amount);
        if ($convert) {
            mlmFire()->db->wallet_record($user_id, 0, 0, $amount, 6, 1, $derscription);
        }
        return $convert;
    }

}