<?php namespace Avans\parts;

class lottery
{ 
    public static function do_lottery($post_id)
    {
        $winners = [];
        $useruse = [];
        $prizes = self::get_prize($post_id);
        $members = self::get_members($post_id);
        $unique = self::get_lottery_members($post_id);

        foreach ($prizes as $prize) {
            if (count($useruse) >= count($unique)) {
                break;
            }

            for ($i=0;$i<$prize->count;$i++) {
                do {
                    $user = self::get_rand_member($members);
                    if (count($useruse) >= count($unique)) {
                        break;
                    }
                } while (in_array($user, $useruse));

                if (count($useruse) >= count($unique)) {
                    break;
                }

                $winners[] = [
                    'user' => $user,
                    'prize' => $prize->name,
                ];

                $useruse[] = $user;
            }
        }
        self::add_winners($post_id, $winners);
        do_action('avans_after_run_lottery',$post_id,$winners);

        return $winners;
    }

    public static function get_prize($post_id)
    {
        $prize = (array)get_post_meta($post_id, AVANS_PREFIX.'lottery_settings', true);
        return $prize['awards'];
    }

    public static function get_lottery_members($post_id)
    {
        $members = self::get_members($post_id);
        $members_count = array_count_values($members);
        return $members_count;
    }

    public static function get_rand_member($members)
    {
        shuffle($members);
        $index = array_rand($members, 1);
        return $members[$index];
    }

    public static function get_members($post_id)
    {
        $members = (array)get_post_meta($post_id, AVANS_PREFIX.'lottery_members', true);
        $members = array_filter($members, function ($value) {
            return !is_null($value) && $value !== '';
        });
        return $members;
    }

    public static function add_winners($post_id, $winners)
    {
        update_post_meta($post_id, AVANS_PREFIX.'lottery_winners', $winners);
    }

    public static function get_winners($post_id)
    {
        return get_post_meta($post_id, AVANS_PREFIX.'lottery_winners', true);
    }
}
