<?php namespace Avans;

class update
{
    public static function is_need_update()
    {
        if (func::is_set(get_option("setting_score_user")) && count((array)get_option(AVANS_PREFIX.'complete_update')) < 6) {
            return true;
        }
        return false;
    }

    public static function update_gift_meta()
    {
        if (self::is_complete_update('update_gift_meta')) {
            return;
        }

        $args = [
            'post_type' => array('avans-gift'),
            'posts_per_page' => -1,
            'numberposts' => -1,
        ];
        $gifts = get_posts($args);
        foreach ($gifts as $gift) {
            $option = get_post_meta($gift->ID, 'avans_gift_settings', true);

            if (func::is_set($option)) {
                $meta = [];
                $meta['score_for_get_gift'] = $option['score_for_get_gift'];
                $meta['avans_type_gift'] = $option['avans_type_gift'];


                switch ($meta['avans_type_gift']) {
                    case 'coupon':
                        $meta['number_of_charecter_coupen'] = $option['number_of_charecter_coupen'];
                        $meta['expire_date_coupen'] = $option['expire_date_coupen'];
                        $meta['value_percent_coupen'] = $option['value_percent_coupen'];
                        $meta['avans_type_coupon_gift'] = $option['avans_type_coupon_gift'];
                        $meta['limited_custom_product_for_copon'] = implode('-', $option['limited_custom_product_for_copon']);
                    break;
                    case 'product':
                        $meta['select_product_for_gift'] = implode('-', $option['select_product_for_gift']);
                    break;
                    case 'custom':
                        $meta['custom_content_for_gift'] = $option['custom_content_for_gift'];
                    break;
                }

                update_post_meta($gift->ID, AVANS_PREFIX.'gift_settings', $meta);
                update_post_meta($gift->ID, AVANS_PREFIX.'gift_score', $meta['score_for_get_gift']);
                update_post_meta($gift->ID, AVANS_PREFIX.'gift_type', $meta['avans_type_gift']);
            }
        }

        self::complete_update('update_gift_meta');
    }

    public static function update_page_meta()
    {
        if (self::is_complete_update('update_page_meta')) {
            return;
        }

        $args = [
            'post_type' => array('page'),
            'posts_per_page' => -1,
            'numberposts' => -1,
        ];
        $pages = get_posts($args);
        foreach ($pages as $page) {
            $active = get_post_meta($page->ID, 'ddo_active_or_noactive_score_page', true);
            if (func::is_set($active)) {
                $meta = [];
                $meta['active'] = ($active == 1) ? true : false;
                $meta['score']  = get_post_meta($page->ID, 'ddo_custom_score_page', true);
                $meta['delay']  = get_post_meta($page->ID, 'ddo_delay_score_page', true);
                $meta['text']   = get_post_meta($page->ID, 'ddo_text_score_page', true);
                update_post_meta($page->ID, AVANS_PREFIX.'meta_score_page', $meta);
            }
        }

        self::complete_update('update_page_meta');
    }

    public static function update_order_meta()
    {
        if (self::is_complete_update('update_order_meta')) {
            return;
        }

        $args = [
            'post_type'   => array( 'shop_order' ),
            'post_status' => array( 'wc-completed','wc-processing' ),
            'posts_per_page' => -1,
            'numberposts' => -1,
        ];
        
        $orders = get_posts($args);
        foreach ($orders as $order) {
            $order_viewed = get_post_meta($order->ID, 'score_order_viewed', true);
            if (func::is_set($order_viewed)) {
                update_post_meta($order->ID, AVANS_PREFIX.'order_viewed', true);
            }

            $order_ref_id = get_post_meta($order->ID, 'score_order_refid', true);
            if (func::is_set($order_ref_id)) {
                update_post_meta($order->ID, AVANS_PREFIX.'wc_ref_order', $order_ref_id);
            }
        }

        self::complete_update('update_order_meta');
    }

    public static function update_all_users_meta()
    {
        if (self::is_complete_update('update_users_meta')) {
            return;
        }
        $users = get_users();
        foreach ($users as $user) {
            $userScore = get_user_meta($user->ID, 'ddo_user_score', true);
            if (func::is_set($userScore)) {
                update_user_meta($user->ID, AVANS_PREFIX.'user_score', (int)$userScore);
                update_user_meta($user->ID, AVANS_PREFIX.'user_score_valid', (int)$userScore);
            }

            $refCode = get_user_meta($user->ID, 'ddo_user_referal_id', true);
            if (func::is_set($refCode)) {
                update_user_meta($user->ID, AVANS_PREFIX.'user_ref_code', $refCode);
            }

            $last_modify_for_daily_visit = get_user_meta($user->ID, 'ddo_last_modified_user_score', true);
            if (func::is_set($last_modify_for_daily_visit)) {
                $time  = jdate('Y-m-d', $last_modify_for_daily_visit);
                update_user_meta($user->ID, AVANS_PREFIX.'last_visit', $time);
            }

            $use_ref_code = get_user_meta($user->ID, 'ddo_is_use_referal_id', true);
            if (func::is_set($use_ref_code)) {
                update_user_meta($user->ID, AVANS_PREFIX.'wc_ref_code', $use_ref_code);
            }

            $use_coupon = get_user_meta($user->ID, 'ddo_is_user_use_coupen', true);
            if (func::is_set($use_coupon)) {
                update_user_meta($user->ID, AVANS_PREFIX.'is_user_use_coupen', true);
            }

            $firstTimeLogin = get_user_meta($user->ID, 'ddo_first_time_login_score', true);
            if (func::is_set($firstTimeLogin)) {
                update_user_meta($user->ID, AVANS_PREFIX.'first_login', true);
            }

            $sound_viewed = get_user_meta($user->ID, 'sound_viewed', true);
            if (func::is_set($sound_viewed)) {
                update_user_meta($user->ID, AVANS_PREFIX.'sound_viewed', $sound_viewed);
            }

            $video_viewed = get_user_meta($user->ID, 'video_viewed', true);
            if (func::is_set($video_viewed)) {
                update_user_meta($user->ID, AVANS_PREFIX.'video_viewed', $video_viewed);
            }

            $pages_viewed = get_user_meta($user->ID, 'pages_viewed', true);
            if (func::is_set($pages_viewed)) {
                update_user_meta($user->ID, AVANS_PREFIX.'page_viewed', $pages_viewed);
            }

            $posts_viewed = get_user_meta($user->ID, 'posts_viewed', true);
            if (func::is_set($posts_viewed)) {
                update_user_meta($user->ID, AVANS_PREFIX.'post_viewed', $posts_viewed);
            }

            $product_viewed = get_user_meta($user->ID, 'product_viewed', true);
            if (func::is_set($product_viewed)) {
                update_user_meta($user->ID, AVANS_PREFIX.'product_viewed', $product_viewed);
            }

            if (func::is_set($product_viewed) || func::is_set($posts_viewed) || func::is_set($pages_viewed)) {
                $posts_types_viewed = array_merge((array)$product_viewed, (array)$posts_viewed, (array)$pages_viewed);
                update_user_meta($user->ID, AVANS_PREFIX.'post_types_viewed', $posts_types_viewed);
            }

            $get_score_birthdate = get_user_meta($user->ID, 'ddo_get_user_gift_birthday', true);
            if (func::is_set($get_score_birthdate)) {
                update_user_meta($user->ID, AVANS_PREFIX.'birthday_gift_getted', true);
            }

            $sco_birthdate = get_user_meta($user->ID, 'sco_birthdate', true);
            if (func::is_set($sco_birthdate)) {
                update_user_meta($user->ID, AVANS_PREFIX.'birthdate', $sco_birthdate);
            }

            $avans_gform_submited = get_user_meta($user->ID, 'avans_gform_submited', true);
            if (func::is_set($avans_gform_submited)) {
                update_user_meta($user->ID, AVANS_PREFIX.'gform_submited', $avans_gform_submited);
            }

            $posts_published = get_user_meta($user->ID, 'posts_published', true);
            if (func::is_set($posts_published)) {
                update_user_meta($user->ID, AVANS_PREFIX.'posts_published', $posts_published);
            }
        }
        self::complete_update('update_users_meta');
    }

    public static function update_options()
    {
        if (self::is_complete_update('update_options')) {
            return;
        }

        $is_import_my_cred = get_option('is_import_from_my_cred_to_score');
        if (func::is_set($is_import_my_cred)) {
            update_option(AVANS_PREFIX.'import_myCred', $is_import_my_cred);
        }
        $is_import_word_points = get_option('is_import_from_word_points_to_score');
        if (func::is_set($is_import_word_points)) {
            update_option(AVANS_PREFIX.'import_wordPoints', $is_import_word_points);
        }
        $is_import_yith = get_option('is_import_from_yith_points_and_rewards_to_score');
        if (func::is_set($is_import_yith)) {
            update_option(AVANS_PREFIX.'import_yitt', $is_import_yith);
        }
        $is_import_ultimate_points = get_option('is_import_from_ultimate_points_and_rewards_to_score');
        if (func::is_set($is_import_ultimate_points)) {
            update_option(AVANS_PREFIX.'import_ultimatePoints', $is_import_ultimate_points);
        }
        $is_apply_last_order_score = get_option('ddo_is_add_score_last_orders');
        if (func::is_set($is_apply_last_order_score)) {
            update_option(AVANS_PREFIX.'apply_last_order_score', $is_apply_last_order_score);
        }

        $settings = get_option('setting_score_user');
        if (func::is_set($settings)) {
            self::upadte_settings((array)$settings);
        }

        self::complete_update('update_options');
    }

    public static function gift_table_update()
    {
        if (self::is_complete_update('update_gift_db')) {
            return;
        }

        global $wpdb;
        $table_name = $wpdb->prefix . "sco_gifts_user";
        if ($wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name) {
            return;
        }

        $query= "SELECT * FROM $table_name ORDER BY id ASC";
        $gifts = $wpdb->get_results($query);
        $table_log = $wpdb->prefix.user::$tabel_log_gift;

        foreach ($gifts as $gift) {
            $wpdb->insert(
                $table_log,
                array(
                    'user' => $gift->user,
                    'gift' => $gift->gift,
                    'content' => self::get_content_gift($gift),
                    'status' => $gift->status,
                    'create_at' => $gift->create_at,
                )
            );
        }
        self::complete_update('update_gift_db');
    }

    public static function get_content_gift($gift)
    {
        $last_content = unserialize($gift->content);
        $content = [];
        switch ($gift->type) {
            case 'coupon':
            $content = [
                'code' => $last_content['code'],
                'args' =>[
                    'expire_date' => $last_content['expire_date'],
                    'type' => 'percent',
                    'amount' => $last_content['amount'],
                    'include_product' => implode('-', $last_content['products']),
                ],
            ];
            break;
            case 'file':
            $content = [
                'args' => [[
                    'url' => $last_content['url'],
                    'name' => 'فایل جایزه',
                ]],
            ];
            break;
            case 'product':
            $content = [
                'order_id' => $last_content['order_id'],
            ];
            break;
            case 'custom':
            $content = [
                'full_content' => $last_content['full_content'],
            ];
            break;
        }
        return serialize($content);
    }

    public static function score_table_update()
    {
        if (self::is_complete_update('update_score_db')) {
            return;
        }

        global $wpdb;
        $table_name = $wpdb->prefix . "sco_score_log";
        if ($wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name) {
            return;
        }

        $query= "SELECT * FROM $table_name ORDER BY id ASC";
        $logs = $wpdb->get_results($query);

        foreach ($logs as $log) {
            $result = self::get_details_log($log);
            $args = [
                'user_id' => $log->user,
                'type' => $result['type'],
                'score' => $log->score,
                'total' => $log->total_score,
                'created_at' => date('Y-m-d H:i:s', $log->time),
            ];

            $insert = self::insert_score_log($args);
            if (!is_wp_error($insert['status'])) {
                foreach ($result['details'] as $detail) {
                    self::insert_details($insert['id'], $detail);
                }
            }
        }
        self::complete_update('update_score_db');
    }

    public static function insert_details($log_id, array $detail)
    {
        global $wpdb;
        $table_meta = $wpdb->prefix.user::$tabel_log_meta;
        global $wpdb;
        $result = $wpdb->insert(
            $table_meta,
            array(
                'log_id' => $log_id,
                'meta_key' => $detail['key'],
                'meta_value' => $detail['value'],
            )
        );
    }

    public static function insert_score_log(array $args)
    {
        if ($args['type'] == 'wc_referer_wallet') {
            $args['score'] = 0;
        }
        global $wpdb;
        $table_log = $wpdb->prefix.user::$table_log;
        $status = $wpdb->insert(
            $table_log,
            array(
                'user' => $args['user_id'],
                'type' => $args['type'],
                'score' => $args['score'],
                'total' => $args['total'],
                'status' => 1,
                'created_at' => $args['created_at'],
                'expire_date' => null,
            )
        );
        $result = [];
        $result['id'] = $wpdb->insert_id;
        $result['status'] = $status;
        return $result;
    }

    public static function upadte_settings($settings)
    {
        $data = [];

        $data['score_settings']['post']['active'] = $settings['is_active_score_posts'];
        $data['score_settings']['post']['score'] = $settings['value_score_view_post'];
        $data['score_settings']['post']['delay'] = $settings['delay_get_score_post'];
        $data['score_settings']['post']['text'] = $settings['text_toast_score_post'];

        $data['score_settings']['product']['active'] = $settings['is_active_score_products'];
        $data['score_settings']['product']['score'] = $settings['value_score_view_product'];
        $data['score_settings']['product']['delay'] = $settings['delay_get_score_product'];
        $data['score_settings']['product']['text'] = $settings['text_toast_score_product'];

        $data['score_settings']['purchase']['active'] = $settings['is_active_score_purchase'];
        $data['score_settings']['purchase']['type'] = $settings['type_model_scoring_prurchase'];
        $data['score_settings']['purchase']['fix_score'] = $settings['value_score_purchase'];
        $data['score_settings']['purchase']['flex_unit'] = $settings['value_price_unit_purchase'];
        $data['score_settings']['purchase']['flex_score'] = $settings['value_score_purchase_by_volume'];
        $data['score_settings']['purchase']['min_price'] = $settings['score_minimum_price_order'];
        $data['score_settings']['purchase']['status'] = $settings['order_status_for_score'];
        $data['score_settings']['purchase']['text'] = $settings['text_toast_score_purchase'];

        $data['score_settings']['comment']['active'] = $settings['is_active_score_comments'];
        $data['score_settings']['comment']['score'] = $settings['value_score_add_comment'];
        $data['score_settings']['comment']['score_wc'] =  $settings['value_score_add_comment_by_purchaser'];

        $data['score_settings']['register']['active'] = $settings['is_active_score_register'];
        $data['score_settings']['register']['score'] = $settings['value_score_register'];
        $data['score_settings']['register']['score_ref'] =  $settings['value_score_referer_register'];
        $data['score_settings']['register']['text'] =  $settings['text_toast_score_register'];

        $data['score_settings']['daily']['active'] = $settings['is_active_score_daily_visit'];
        $data['score_settings']['daily']['score'] = $settings['value_score_daily_visit'];
        $data['score_settings']['daily']['delay'] =  $settings['delay_get_score_daily_visit'];
        $data['score_settings']['daily']['text'] =  $settings['text_toast_score_daily_visit'];

        $data['score_settings']['share']['active'] = $settings['is_active_score_share_link'];
        $data['score_settings']['share']['score'] = $settings['value_score_share_link'];
        $data['score_settings']['share']['delay'] =  $settings['delay_get_score_share_link'];
        $data['score_settings']['share']['limit'] = ['value' => $settings['max_get_score_daily_share_link'] , 'unit' => 'day'];

        $data['score_settings']['publish']['active'] = $settings['is_active_score_publish_post'];
        $data['score_settings']['publish']['score'] = $settings['value_score_publish_post'];

        $data['score_settings']['birthday']['active'] = $settings['is_active_score_birthday'];
        $data['score_settings']['birthday']['editable'] = $settings['is_active_show_birth_day_field_in_woopanel'];
        $data['score_settings']['birthday']['score'] = $settings['value_score_score_birthday'];

        $data['score_settings']['registerday']['active'] = $settings['is_active_score_registerd_date'];
        $data['score_settings']['registerday']['score'] = $settings['value_score_registerd_date'];

        $data['convert_settings']['wallet']['active'] =  $settings['is_active_convert_wallet'] === 'true' ? true : false;
        $data['convert_settings']['wallet']['cost_unit'] = $settings['cost_of_unit_score'];
        $data['convert_settings']['wallet']['min_score'] =  $settings['minimum_score_for_convert_wallet'];

        $data['coupen_settings']['after-order']['active'] = $settings['is_active_generation_coupen'] ? 'true' : 'false';
        $data['coupen_settings']['after-order']['num_char'] = $settings['number_of_charecter_coupen'];
        $data['coupen_settings']['after-order']['expire'] = $settings['expire_date_coupen'];
        $data['coupen_settings']['after-order']['value'] = $settings['value_percent_coupen'];
        $data['coupen_settings']['after-order']['type'] = 'percent';
        $data['coupen_settings']['after-order']['min_price'] = $settings['minimum_total_price_for_send_cuppen'];
        $data['coupen_settings']['after-order']['min_orders'] = $settings['minimum_total_orders_for_send_cuppen'];
        $data['coupen_settings']['after-order']['repeat'] = $settings['is_send_cuppen_time_for_user'];

        $data['panel_settings']['show_telegram'] =  $settings['is_active_show_icon_telegram'];
        $data['panel_settings']['show_whatsapp'] =  $settings['is_active_show_icon_whatsapp'];
        $data['panel_settings']['show_twiter'] =  $settings['is_active_show_icon_twiter'];
        $data['panel_settings']['show_linkdin'] =  $settings['is_active_show_icon_linkdin'];
        $data['panel_settings']['show_facebook'] =  $settings['is_active_show_icon_facebook'];
        $data['panel_settings']['show_email'] =  $settings['is_active_show_icon_email'];
        $data['panel_settings']['show_panel'] = 'true';
        $data['panel_settings']['show_gift'] = 'true';
        $data['panel_settings']['show_score_logs'] = 'true';
        $data['panel_settings']['show_convert_wallet'] = 'true';
        $data['panel_settings']['show_referers'] = 'true';
        $data['panel_settings']['show_faq'] = 'true';


        $data['referer_settings']['referer']['active'] = $settings['is_active_score_referal_code'];
        $data['referer_settings']['referer']['format'] = $settings['format_code_referal'];
        $data['referer_settings']['referer']['format_suffix'] = $settings['suffix_format_code_referal'];
        $data['referer_settings']['referer']['format_prefix'] = $settings['prefix_format_code_referal'];
        $data['referer_settings']['referer']['repeat'] = $settings['count_use_from_code_referal'];
        $data['referer_settings']['referer']['fee'] = $settings['value_fee_referal_code'];
        $data['referer_settings']['referer']['ref_gift'] = $settings['value_score_referal_user'];
        $data['referer_settings']['referer']['fee_type'] = $settings['type_score_referal_user'];
        $data['referer_settings']['referer']['day_coocki'] = $settings['value_day_referal_code_coocki'];

        $data['general_settings']['sms']['service'] = $settings['score_select_sms_type'];
        $data['general_settings']['permision']['users'] = implode('-', $settings['score_users_blocked']);
 
        update_option('avans_plugin_setting', $data);
    }

    public static function get_details_log($log)
    {
        $detail = unserialize($log->details);
        $details = [];
        $type = '';
        switch ($log->type) {
            case 1:
                $details = [['key'=>'post-id','value'=> $log->post_id]];
                $type = 'view-post';
                break;
            case 2:
                $details = [['key'=>'post-id','value'=> $log->post_id]];
                $type = 'view-product';
                break;
            case 3:
                $details = [['key'=>'post-id','value'=> $log->post_id]];
                $type = 'view-page';
                break;
            case 4:
                $details = [['key'=>'order_id','value'=> $log->object_id]];
                $type = 'wc_order';
                break;
            case 5:
                $type = "daily-visit";
                break;
            case 6:
                $details = array(
                    array(
                        'key' => 'post_id',
                        'value' => $log->post_id,
                    ),
                    array(
                        'key' => 'object_id',
                        'value' => $log->object_id,
                    )
                );
                $type = "view-video";
                break;
            case 7:
                $details = array(
                    array(
                        'key' => 'post_id',
                        'value' => $log->post_id,
                    ),
                    array(
                        'key' => 'object_id',
                        'value' => $log->object_id,
                    )
                );
                $type = "view-sound";
                break;
            case 8:
                $type = "convert-wallet";
                break;
            case 9:
                $type = "register";
                break;
            case 10:
                $details = [
                    array(
                        'key' => 'post_id',
                        'value' => $log->post_id
                    )
                ];
                $type = "publish-post";
                break;
            case 11:
                $details = [
                    array(
                        'key' => 'post_id',
                        'value' => $log->post_id
                    ),
                ];
                $type = "comment";
                break;
            case 12:
                $type = "wc_referer";
                break;
            case 13:
                $type = "wc_referer";
                break;
            case 14:
                $type = "wc_referer_wallet";
                $details = [['key' => 'amount','value' => $log->score ]];
                break;
            case 15:
                if (func::is_set($detail['title'])) {
                    $details = [['key' => 'title','value' => $detail['title'] ]];
                }
                $type = "admin";
            break;
            case 16:
                if (func::is_set($detail['title'])) {
                    $details = [['key' => 'title','value' => $detail['title']]];
                }
                $type = "admin";
            break;
            case 17:
                $details = [
                    array(
                        'key' => 'post_id',
                        'value' => $log->post_id,
                    )
                ];
                $type = "share-link";
            break;
            case 18:
                $type = "birthday";
            break;
            case 19:
                $type = "registerday";
            break;
            case 20:
                $details = array(
                    array(
                        'key' => 'form_id',
                        'value' => $log->post_id,
                    ),
                );
                $type = "submit_gform";
            break;
            case 22:
                $type = "ref-register";
            break;
            case 23:
                $details = [['key' => 'gift-id','value' => $log->post_id]];
                $type = "gifts";
            break;
        }

        $result = [
            'type' => $type,
            'details' => $details,
        ];

        return $result;
    }

    public static function is_complete_update($key)
    {
        $option = get_option(AVANS_PREFIX.'complete_update', []);
        if (in_array($key, $option)) {
            return true;
        }
        return false;
    }

    public static function complete_update($key)
    {
        $option = get_option(AVANS_PREFIX.'complete_update', []);
        if (!in_array($key, $option)) {
            array_push($option, $key);
            update_option(AVANS_PREFIX.'complete_update', $option);
        }
    }
}
