<?php namespace Avans;

use Avans\parts\completeProfile;
use Avans\parts\convert;
use Avans\parts\gifts;
use Avans\parts\lottery;
use Avans\parts\spin_wheel;
use stdClass;

class user
{
    public static $table_log = 'avans_log_score';
    public static $tabel_log_meta = 'avans_log_meta';
    public static $tabel_log_gift = 'avans_log_gifts_getted';

    public static function get_score(int $user_id)
    {
        $score = (int)get_user_meta($user_id, AVANS_PREFIX.'user_score', true);
        $score = apply_filters('avans_get_score',$score,$user_id);
        return $score;
    }

    public static function set_score(int $user_id, int $score,$type)
    {

        if(class_exists("\DrClubs\main")){
            return 0;
        }

        $method = (null !== AVANS_SETTINGS['general_settings']['decrease_method']) ? AVANS_SETTINGS['general_settings']['decrease_method'] : 'decrease';
        $userScore = self::get_score($user_id);

        if(  $method == 'static' ){
            if(   $score > 0  || ( $score < 0 && in_array($type,array('admin')) )   ){
                $totalScore = ($userScore + (int)$score) > 0 ? ($userScore + (int)$score) : 0;
                update_user_meta($user_id, AVANS_PREFIX.'user_score', $totalScore );
            }
        }else{
            $totalScore = ($userScore + (int)$score) > 0 ? ($userScore + (int)$score) : 0;
            update_user_meta($user_id, AVANS_PREFIX.'user_score', $totalScore );
        }

        return self::get_score($user_id);
    }

    public static function get_score_valid(int $user_id)
    {
        $score = (int)get_user_meta($user_id, AVANS_PREFIX.'user_score_valid', true);
        $score = apply_filters('avans_get_score_valid',$score,$user_id);
        return $score;
    }

    public static function set_score_valid(int $user_id, int $score)
    {
        if(class_exists("\DrClubs\main")){
            return 0;
        }

        $userScore = self::get_score_valid($user_id);
        $totalScore = ($userScore + (int)$score) > 0 ? ($userScore + (int)$score) : 0;
        update_user_meta($user_id, AVANS_PREFIX.'user_score_valid', $totalScore );
        return self::get_score_valid($user_id);
    }

    public static function add_log(
        int $user_id, string $type, array $details = array(), int $score = null,array $expier = array())
    {
        global $wpdb;
        $table_log = $wpdb->prefix.self::$table_log;
        $table_meta = $wpdb->prefix.self::$tabel_log_meta;

        if (!isset($score)) {
            $score = (int)data::get_action_score($type, $user_id);
        }

        if($score > 0 && !data::is_validate_score($type)){
            $score =  self::get_valid_score($user_id,$score);
        }

        if ($score==0) {
            return false;
        }

        $total = self::set_score_valid($user_id, $score);
        self::set_score($user_id, $score, $type);

        $time = current_time('mysql');
        $exptime = data::get_expire_time(data::get_root_data_action($type),$score,$expier);

        $main = $wpdb->insert(
            $table_log,
            array(
                'user' => $user_id,
                'type' => $type,
                'score' => $score,
                'total' => $total,
                'status' => 1,
                'created_at' => $time,
                'expire_date' => $exptime,
            )
        );
        
        $log_id = $wpdb->insert_id;


        if (!is_wp_error($main)) {
            foreach ($details as $detail) {
                $result = $wpdb->insert(
                    $table_meta,
                    array(
                        'log_id' => $log_id,
                        'meta_key' => $detail['key'],
                        'meta_value' => $detail['value'],
                    )
                );
            }
        }

        update_user_meta($user_id, AVANS_PREFIX.'temp_max_score', '');

        do_action('avans_after_change_score',$type,$score,$total,$details,$user_id);

        return $score;
    }

    public static function get_valid_score($user_id,$score,$is_order=false){
        $maxscore = get_user_meta($user_id,AVANS_PREFIX.'temp_max_score',true);
        if( (int)$maxscore < 0 || empty($maxscore) ){
            return (int)$score;
        }
        if((int)$score <= (int)$maxscore){
            return (int)$score;
        }
        if($is_order){
            return (int)$maxscore;
        }
        return 0;
    }

    public static function add_gift_log($gift_id, $user_id, $status, $args)
    {
        global $wpdb;
        $table_log = $wpdb->prefix.self::$tabel_log_gift;
        $res = $wpdb->insert(
            $table_log,
            array(
                'user' => $user_id,
                'gift' => $gift_id,
                'content' => serialize($args),
                'status' => $status,
                'create_at' => current_time('mysql'),
            )
        );
        return $res;
    }

    public static function get_ref_code(int $user_id)
    {
        $ref_code = get_user_meta($user_id, AVANS_PREFIX.'user_ref_code', true);
        return $ref_code;
    }

    public static function get_ref_link(int $user_id, int $page_id = null,$custom = null)
    {
        $ref_code = get_user_meta($user_id, AVANS_PREFIX.'user_ref_code', true);
        $url = add_query_arg('referer', $ref_code, home_url()) ;
        if (func::is_set($page_id)) {
            $url = add_query_arg('p', $page_id, $url);
        }
        if (func::is_set($custom)) {
            $url = add_query_arg('referer', $ref_code, $custom) ;
        }
        return $url;
    }

    public static function avans_create_refere_code()
    {
        $user_id = get_current_user_id();

        $referer = AVANS_SETTINGS['referer_settings']['referer'];
        if($user_id == 0 || !$referer['active']){
            return;
        }

        $ref = get_user_meta($user_id, AVANS_PREFIX.'user_ref_code', true);
        if (empty($ref)) {
            if (empty($referer['format']) || $referer['format'] == 'auto') {
                $refcode = chr(rand(97, 122)).rand('11', '99').$user_id.chr(rand(97, 122)).rand('11', '99');
            } else {
                $refcode = $referer['format_prefix'].chr(rand(97, 122)).rand('11', '99').get_current_user_id().chr(rand(97, 122)).rand('11', '99').$referer['format_suffix'];
            }
            update_user_meta($user_id, AVANS_PREFIX.'user_ref_code', $refcode);
        }
        
    }

    public static function get_role(int $user_id)
    {
        $user = get_user_by('ID', $user_id);
        $role = (array)$user->roles[0];
        return $role[0];
    }

    public static function get_level(int $user_id)
    {
        $score  = self::get_score($user_id);
        $levels =  (array)data::get_levels();

        for ($i=0;$i<count($levels);$i++) {
            if ($score > $levels[$i]->score) {
                return $levels[$i]->name;
            }
        }

        return null;
    }

    public static function add_gift_to_user($gift_id, $user_id)
    {
        $score = get_post_meta($gift_id, AVANS_PREFIX.'gift_score', true);
        $user_score = self::get_score_valid($user_id);
        if ($user_score >= $score) {
            $gifts = new gifts($gift_id, $user_id);
            $arg = $gifts->add_gifts();
            $details = [['key' => 'gift-id','value' => $gift_id]];
            self::add_log($user_id, 'gifts', $details, (int)-$score);
            $insert = self::add_gift_log($gift_id, $user_id, 'completed', $arg);
            if (!is_wp_error($insert)) {
                do_action('avans_after_get_prize',$gift_id,$arg);
                return $arg;
            }
        }
        return false;
    }


    public static function get_user_getted_gifts($user_id, $page, $type='all')
    {
        global $wpdb;
        $table_log = $wpdb->prefix.self::$tabel_log_gift;
        $per_page = 10;
        $query = "SELECT * FROM {$table_log} WHERE user = {$user_id}";
        $total= $wpdb->get_var("SELECT COUNT(1) FROM ($query) AS combined_table");
        $offset = ($page * $per_page) - $per_page;
        $sql = " ORDER BY id DESC LIMIT $offset,$per_page ";
        $results  = $wpdb->get_results($query.$sql);
        $total_page = ceil($total / $per_page);

        $result = [
            'query' => $query,
            'total' => $total,
            'page' => $page,
            'total_page' => $total_page,
            'result' => $results
        ];

        return $result;
    }

    public static function get_gift_record($gift_log_id, $user_id)
    {
        global $wpdb;
        $table_log = $wpdb->prefix.self::$tabel_log_gift;
        $query = "SELECT * FROM {$table_log} WHERE id = %d";
        $result = $wpdb->get_row($wpdb->prepare($query, $gift_log_id));

        if (!empty($result) && (int)$result->user == (int)$user_id) {
            return $result;
        }
        return false;
    }

    public static function get_wallet_amount($user_id)
    {
        $option = AVANS_SETTINGS['convert_settings']['wallet'];
        $unit   = (int)$option['cost_unit'];
        $score  = user::get_score_valid((int)$user_id);
        $amount = $score * $unit;
        if ($amount > 0) {
            return $amount;
        }
        return 0;
    }

    public static function is_permision_convert_wallet($user_id){
        if(self::is_user_block($user_id)){
            return false;
        }
        $limit = AVANS_SETTINGS['convert_settings']['wallet']['limit'];
        $min_score = (int)AVANS_SETTINGS['convert_settings']['wallet']['min_score'];
        $user_score = self::get_score_valid($user_id);
        
        if($min_score > 0 &&  $user_score < $min_score ){
            return $min_score - $user_score;
        }

        if((int)$limit['value'] <= 0){
            return true;
        }
        global $wpdb;
        $tbl = $wpdb->prefix.self::$table_log;
        $value = (int)$limit['value'];
        $unit = !empty($limit['unit']) ? $limit['unit'] : 'day';
        $limitTime =  date("Y-m-d", strtotime("-1 $unit"));
        $query = "SELECT * FROM $tbl WHERE user = $user_id AND type = 'convert-wallet' AND created_at >= '$limitTime'  ";
        $count = (int)$wpdb->get_var("SELECT COUNT(1) FROM ($query) AS combined_table");
        if($count < $value){
            return true;
        }
        return false;
    }


    public static function convert_wallet(int $user_id)
    {
        $settings = AVANS_SETTINGS['convert_settings']['wallet'];
        $result = new stdClass;
        $result->success = false;

        if(!$settings['active'] || (int)$settings['cost_unit'] <= 0){
            $result->message = sprintf(__('سیستم تبدیل %s به کیف پول غیر فعال می باشد.'),func::get_score_label());
            return $result;
        }
        
        $user_score = self::get_score_valid($user_id);
        if($user_score <= 0 || $user_score < (int)$settings['min_score']){
            $result->message = sprintf(__('شما %s لازم برای این عملیات را ندارید!'),func::get_score_label());
            return $result;
        }

        $is_permision_convert = self::is_permision_convert_wallet($user_id);
        if (!$is_permision_convert) {
            $result->message = __('شما مجوز لازم برای عملیات را ندارید');
            return $result;
        }


        $amount = self::get_wallet_amount($user_id);
        $score = self::get_score_valid($user_id);
        $description = sprintf(__('تبدیل %s به اعتبار کیف پول'),func::get_score_label(true));
        $convert = convert::wallet_transaction($user_id, $amount,$description);
        if ($convert) {
            self::add_log($user_id, 'convert-wallet', array(), -$score);
            $result->success = true;
            $result->message = __('عملیات تبدیل با موفقیت انجام شد');

            do_action('avans_after_convert_to_wallet', $amount, $score);

            return $result;

        }
        $result->message = sprintf(__('در فرآیند تبدیل %s به کیف پول خطا ایجاد شد!'),func::get_score_label());
        return $result;
    }

    public static function get_prize_spin_wheel(int $user_id, int $wheel_id)
    {
        $options = get_post_meta($wheel_id, AVANS_PREFIX.'spin_wheel_settings', true);
        
        if( isset($options['is_active_free_spin']) && $options['is_active_free_spin']){

            if(isset($options['duration']) && self::is_permision_get_prize_by_duration_time($options['duration'],$user_id,$wheel_id)){
                return self::spin_wheel_by_duration_time($options,$user_id,$wheel_id);
            }else{
                return self::spin_wheel_by_score($options,$user_id,$wheel_id);
            }

        }else{
            return self::spin_wheel_by_score($options,$user_id,$wheel_id);
        }

        return false;
    }

    public static function spin_wheel_by_duration_time($options,$user_id,$wheel_id){
        $prize = new spin_wheel($wheel_id, $user_id);
        $result = $prize->get_prize();

        if ($result !== false) {
            self::add_gift_log($wheel_id, $user_id, 'completed', $result['result']);
            update_user_meta($user_id, AVANS_PREFIX.'spin_wheel_'.$wheel_id.'_last_use_time', time());
            do_action('avans_after_spin_wheel_rotated',$wheel_id, $options['score'],$result['result']);
            return $result;
        } else {
            return [
                'error' => true,
                'msg' => 'خطا در دریافت جایزه'
            ];
        }
    }


    
    public static function spin_wheel_by_score($options,$user_id,$wheel_id){
        if (self::get_score_valid($user_id) >= (int)$options['score']) {
            $prize = new spin_wheel($wheel_id, $user_id);
            $result = $prize->get_prize();

            if ($result !== false) {
                $details = [['key' => 'wheel-id','value' => $wheel_id]];
                self::add_log($user_id, 'spin-wheel', $details, -(int)$options['score']);
                self::add_gift_log($wheel_id, $user_id, 'completed', $result['result']);
                do_action('avans_after_spin_wheel_rotated',$wheel_id,-(int)$options['score'],$result['result']);
                return $result;
            }else{
                return [
                    'error' => true,
                    'msg' => 'خطا در دریافت جایزه'
                ];

            }

        }else{
            return [
                'error' => true,
                'msg' => sprintf(__('%s شما برای استفاده از گردونه شانس کافی نیست!'),func::get_score_label())
            ];
        }
    }


    public static function is_permision_get_prize_by_duration_time($duration_options,$user_id,$wheel_id){
        $time_value = (int)$duration_options['value'];
        $time_unit = $duration_options['unit'];
        $last_time_use = (int)get_user_meta($user_id,AVANS_PREFIX.'spin_wheel_'.$wheel_id.'_last_use_time',true);
        if($last_time_use > 0){
            
            $time_unit = (int)func::covert_string_time_to_timestamp($time_unit);
            $time_valid = $time_value * $time_unit;

            if( ($last_time_use + $time_valid) < time() ){
                return true;
            }else{
                return false;
            }

        }
        return true;
    }

    public static function get_lottery_tickets($lottey_id, $count, $user)
    {
        $winners = func::get_array_without_empty((array)lottery::get_winners($lottey_id));
        $result = new stdClass;
        $result->success = false;
        if(count($winners) > 0){
            $result->message = __("ثبت نام در این قرعه کشی به پایان رسیده است!");
            return $result;
        }
        $option = get_post_meta($lottey_id, AVANS_PREFIX.'lottery_settings', true);
        $members = (array)get_post_meta($lottey_id, AVANS_PREFIX.'lottery_members', true);
        $member_chance = array_count_values($members);
        $total_chance = (int)$member_chance[$user] + (int)$count;
        $score = $count * $option['score'];
        if (user::get_score_valid($user) >= $score  && $score > 0 && $total_chance <= (int)$option['max_chance']) {
            for ($i=0;$i<$count;$i++) {
                array_push($members, $user);
            }
            update_post_meta($lottey_id, AVANS_PREFIX.'lottery_members', $members);
            $details = [['key' => 'lottery-id','value' => $lottey_id],['key' => 'count','value' => $count]];
            self::add_log($user, 'lottery', $details, -$score);
            $result->success = true;
            $result->message = __("ثبت نام در قرعه کشی با موفقیت انجام شد.");

            do_action('avans_after_get_lottery_tickets',$lottey_id,$score,$count,$total_chance);

            return $result;
        }

        $result->message = __("شما شرایط لازم برای تهیه بلیط قرعه کشی را ندارید.");
        if(user::get_score_valid($user) < $score){
            $result->message = sprintf(__("شما %s کافی برای تهیه بلیط قرعه کشی را ندارید!"),func::get_score_label());
        }
        if ($total_chance >= (int)$option['max_chance']) {
            $result->message = __("شما نمی توانید بیشتر از حداکثر بلیط قابل رزرو ، تهیه کنید!");
        }

        return $result;
    }

    public static function get_customer_total_order($user)
    {
        $customer_orders = get_posts(array(
            'numberposts' => -1,
            'meta_key'    => '_customer_user',
            'meta_value'  => $user->ID,
            'post_type'   => array( 'shop_order' ),
            'post_status' => array( 'wc-completed','wc-processing' )
        ));
        $total = 0;
        foreach ($customer_orders as $customer_order) {
            $order = wc_get_order($customer_order);
            $totalOrder = data::get_total_order($order);
            $total += $totalOrder;
        }
        return $total;
    }

    public static function is_in_array_meta_step_badge($user, $badge_id, $step_index)
    {
        $indexes = self::get_meta_step_badge($user, $badge_id);

        if (in_array($step_index, $indexes, true)) {
            return true;
        }
        return false;
    }

    public static function get_meta_step_badge($user, $badge_id)
    {
        $badge = (array)get_user_meta($user->ID, AVANS_PREFIX.'step_badge_'.$badge_id, true);
        $badge = func::get_array_without_empty($badge);
        $badge = array_unique($badge);
        return $badge;
    }

    public static function get_badges_user($user_id){
        $badges = (array)get_user_meta($user_id, AVANS_PREFIX.'badges', true);
        $badges = func::get_array_without_empty($badges);
        $badges = array_unique($badges);
        return $badges;
    }

    public static function add_badge_to_badges_user($user_id,$badge_id){
        $badges = self::get_badges_user($user_id);
        if(!in_array($badge_id,$badges)){
            array_push($badges,$badge_id);
            update_user_meta($user_id, AVANS_PREFIX.'badges', $badges);
            do_action('avans_after_badge_getted',$badge_id,$badges);
        }
    }

    public static function check_is_get_badge($user_id,$steps,$badge_id){
        $user = get_user_by('ID',$user_id);
        
        $user_steps = self::get_meta_step_badge($user, $badge_id);

        if(count($steps) == 0 || count($user_steps)==0){
            return;
        }

        $badge_steps = [];
        foreach ($steps as $index => $step) {
          $badge_steps[] = $index;          
        }

        if(func::is_arrays_equal($user_steps,$badge_steps)){
            self::add_badge_to_badges_user($user->ID,$badge_id);
        }
        
    }

    public static function add_meta_step_badge($user, $badge_id, $step_index)
    {
        $indexes = self::get_meta_step_badge($user, $badge_id);
        if(!in_array($step_index,$indexes)){
            array_push($indexes, $step_index);
            update_user_meta($user->ID, AVANS_PREFIX.'step_badge_'.$badge_id, $indexes);
        } 
    }

    public static function get_data($user_id)
    {
        $user = get_user_by('ID', $user_id);
        $data = new stdClass;
        $data->fullname = $user->display_name;
        $data->username = $user->user_login;
        $data->user_date = $user->user_registered;
        return $data;
    }

    public static function is_post_star_rated($post_id, $user_id)
    {
        $posts = (array)get_user_meta($user_id, AVANS_PREFIX.'posts-rated', true);
        if ($user_id==0 || in_array($post_id, $posts)) {
            return true;
        }
        return false;
    }

    public static function is_user_block($user_id){
        $settings = AVANS_SETTINGS['general_settings']['permision'];
        $user = get_user_by('ID',$user_id);

        if ( count(array_intersect( (array)$user->roles , (array)$settings['roles']) ) > 0 ) {
            return true;
        }

        if( in_array($user_id , (array)$settings['users'] ) ){
            return true;
        }

        return false;

    }

    public static function is_permision_get_score( $action, $user_id )
    {
        if(self::is_user_block($user_id)){
            return false;
        }

        global $wpdb;
        $tbl = $wpdb->prefix.self::$table_log;
        $setting_route = data::get_root_data_action($action);
        $limit = $setting_route['limit'];

        if (empty($limit['value'])) {
            update_user_meta($user_id,AVANS_PREFIX.'temp_max_score',-1);
            return true;
        }

        $value = $limit['value'];
        $unit = !empty($limit['unit']) ? $limit['unit'] : 'day';
        $limitTime =  date("Y-m-d", strtotime("-1 $unit"));

        $score = $wpdb->get_var("SELECT sum(score) FROM $tbl WHERE user = $user_id AND type = '$action' AND created_at >= '$limitTime'  ");

        if ((int)$score < (int)$value) {
            $max = (int)$value - (int)$score;
            update_user_meta($user_id,AVANS_PREFIX.'temp_max_score',$max);
            return true;
        }

        return false;
    }

    public static function get_expire_date_action_score($setting_type)
    {
        $limit = AVANS_SETTINGS['score_settings'][$setting_type]['expire'];

        if (empty($limit['value'])) {
            return date("Y-m-d", strtotime("+100 year"));
        }

        $value = $limit['value'];
        $unit = !empty($limit['unit']) ? $limit['unit'] : 'day';
        $extime =  date("Y-m-d", strtotime("$value $unit"));
   
        return $extime;
    }


    public static function find_by_ref($refcode){
        $users = get_users(array('meta_key' => AVANS_PREFIX.'user_ref_code' , 'meta_value' => $refcode));
        return $users;
    }

    public static function get_user_info($user_id){
        $data = new stdClass;
        $user = get_user_by('ID',$user_id);
        $data->display_name = $user->display_name;
        $data->username = $user->user_login;
        $data->firstname = $user->first_name;
        $data->lastname = $user->last_name;
        $data->email = $user->user_email;
        $data->mobile = data::get_user_mobile($user_id);
        $data->avatar = get_avatar_url($user->ID);
        $data->birhdate = self::get_jalali_birhdate($user_id);
        return $data;
    }

    
    public static function get_jalali_birhdate($user_id){
        $birthday = get_user_meta($user_id, AVANS_PREFIX.'birthdate', true);
        if(!empty($birthday)){
            $birthday = func::convert_miladi_to_jalali($birthday);
            if(is_array($birthday)){
                $birthday = $birthday[0].'/'.$birthday[1].'/'.$birthday[2];
            }
        }
        return $birthday;
    }
    
    public static function get_total_orders_price($user_id) {
        $customer_orders = get_posts( array(
            'numberposts' => - 1,
            'meta_key'    => '_customer_user',
            'meta_value'  => $user_id,
            'post_type'   => array( 'shop_order' ),
            'post_status' => array( 'wc-completed','wc-processing' )
        ) );
        $total = 0;
        foreach ( $customer_orders as $customer_order ) {
            $order = wc_get_order( $customer_order );
            $totalOrder = data::get_total_order($order);
            $total += $totalOrder;
        }
        return $total;
    }


    public static function export_users_info($user_id,$option){
        $data = [];
        $user = get_user_by('ID',$user_id);

        if(in_array('fullname',$option)){
            $data['fullname'] = $user->first_name.' '.$user->last_name;
        }

        if(in_array('username',$option)){
            $data['username'] = $user->user_login;
        }

        if(in_array('mobile',$option)){
            $data['mobile'] = data::get_user_mobile($user_id);;
        }

        if(in_array('email',$option)){
            $data['email'] = $user->user_email;
        }

        if(in_array('score',$option)){
            $data['score'] = self::get_score($user_id);
        }

        if(in_array('score_valid',$option)){
            $data['score_valid'] = self::get_score_valid($user_id);
        }

        if(in_array('level',$option)){
            $data['level'] = self::get_level($user_id);
        }

        if(in_array('refere_code',$option)){
            $data['refere_code'] = self::get_ref_code($user_id);
        }

        if(in_array('role',$option)){
            $data['role'] = self::get_role($user_id);
        }

        if(in_array('birthdate',$option)){
            $data['birthdate'] = self::get_jalali_birhdate($user_id);
        }

        if(in_array('last_active',$option)){
            $data['last_active'] = jdate('Y/m/d',get_user_meta($user_id,'wc_last_active',true),'', get_option('timezone_string'),'en');
        }

        if(in_array('verify_status',$option)){
            $data['verify_status'] = (int)completeProfile::check_for_apply_score($user_id) > 0 ? 'yes' : 'no';
        }

        return $data;

    }



}
