jQuery(document).ready(function ($) {
  function spinWhellRotate(avans_spin_wheel) {
      var padding = { top: 20, right: 40, bottom: 0, left: 40 },
        w = 500 - padding.left - padding.right,
        h = 600 - padding.top - padding.bottom,
        r = Math.min(w, h) / 2,
        rotation = 0,
        oldrotation = 0,
        picked = 100000,
        oldpick = [],
        // color = d3.scale.category20();
        bgcolor = [
          "#3579ae",
          "#835ac4",
          "#b35b9f",
          "#d94a83",
          "#f4796d",
          "#f3974c",
          "#ffba4f",
          "#f3da35",
          "#aad066",
          "#3bad61",
          "#57c4a4",
          "#43b9d1",
        ];
      
      txtcolor = ['#fff', '#000'];
      

      var data = [];
        // console.log(avans_spin_wheel);
        $.each(avans_spin_wheel.list, function (i,v) {
            var part = {
                label: v.title,
                value: i,
                stock: v.stock,
                chance: v.possibility,
                background: v.background,
                color : v.color
            };
            data.push(part);
        });

        // console.log(data);

      // {"label" : "Question 1", "value":1,"stock":5,"chance":25,"color":'#57c4a4'}, // padding

      function fillArray(value, len) {
        var arr = [];
        for (var i = 0; i < len; i++) {
        //   console.log(value.length);
          for (var j = 0; j < value.length; j++) {
            // console.log(value[j]);
            arr.push(value[j]);
          }
        }
        return arr;
      }

      bgcolors = fillArray(bgcolor, data.length);
      txtcolors = fillArray(txtcolor, data.length);

    //   console.log(colors);

      function shuffle(array) {
        var currentIndex = array.length,
          temporaryValue,
          randomIndex;

        while (0 !== currentIndex) {
          // Pick a remaining element...
          randomIndex = Math.floor(Math.random() * currentIndex);
          currentIndex -= 1;

          // And swap it with the current element.
          temporaryValue = array[currentIndex];
          array[currentIndex] = array[randomIndex];
          array[randomIndex] = temporaryValue;
        }

        return array[Math.floor(Math.random() * array.length)];
      }

      var svg = d3
        .select("#avans_spin_wheel_holder")
        .append("svg")
        .data([data])
        .attr("width", w + padding.left + padding.right)
        .attr("height", h + padding.top + padding.bottom);

      var container = svg
        .append("g")
        .attr("class", "chartholder")
        .attr(
          "transform",
          "translate(" +
            (w / 2 + padding.left) +
            "," +
            (h / 2 + padding.top) +
            ")"
        );

      var vis = container.append("g");

      vis
        .append("circle")
        .attr("cx", 0)
        .attr("cy", 0)
        .attr("r", 240)
        .style({ fill: "#43486a" });

      var pie = d3.layout
        .pie()
        .sort(null)
        .value(function (d) {
          return 1;
        });
      // declare an arc generator function
      var arc = d3.svg.arc().outerRadius(r);
      // select paths, use arc generator to draw
      var arcs = vis
        .selectAll("g.slice")
        .data(pie)
        .enter()
        .append("g")
        .attr("class", "slice");

      arcs
        .append("path")
        .attr("fill", function (d, i) {
          if (data[i].background.length > 0) {
            itemBgcolor = data[i].background;
          } else {
            itemBgcolor = bgcolors[i];
          }
          return itemBgcolor;
        })
        .attr("d", function (d) {
          return arc(d);
        });

      arcs
        .append("text")
        .attr("transform", function (d) {
          d.innerRadius = 0;
          d.outerRadius = r;
          d.angle = (d.startAngle + d.endAngle) / 2;
          return (
            "rotate(" +
            ((d.angle * 180) / Math.PI - 90) +
            ")translate(" +
            (d.outerRadius - 10) +
            ")"
          );
        })
        .attr("text-anchor", "start")
        .attr("fill", function (d, i) {
          if (data[i].color.length > 0) {
            itemBgcolor = data[i].color;
          } else {
            itemBgcolor = txtcolors[i];
          }
          return itemBgcolor;
        })
        .style({ "font-size": "13px" })
        .text(function (d, i) {
          return data[i].label;
        });

      arcs
        .append("rect")
        .attr("transform", function (d) {
          d.innerRadius = 0;
          d.outerRadius = r;
          d.angle = (d.startAngle + d.endAngle) / 2;
          return (
            "rotate(" +
            ((d.angle * 180) / Math.PI - 90) +
            ")translate(" +
            (d.outerRadius - 10) +
            ")"
          );
        })
        .attr("x", 5)
        .attr("y", 66)
        .attr("width", 15)
        .attr("height", 15)
        .attr("rx", 10)
        .attr("ry", 10)
        .style({ fill: "#fff3c4" });

      container
        .append("circle")
        .attr("cx", 0)
        .attr("cy", 0)
        .attr("r", 60)
        .style({ fill: "#43486a" });

      container
        .append("circle")
        .attr("cx", 0)
        .attr("cy", 0)
        .attr("r", 40)
        .style({ fill: "#fff3c4" });

      container
        .append("g")
        .attr("transform", "translate(55)")
        .append("path")
        .attr(
          "d",
          "M+" + r * 0.15 + ",0L0," + r * 0.08 + "L0,-" + r * 0.08 + "Z"
        )
        .style({ fill: "#43486a" });

      container
        .append("text")
        .attr("x", 0)
        .attr("y", 0)
        .attr("class", "number_chance")
        .attr("text-anchor", "middle")
        .text(avans_spin_wheel.chance_user)
        .style({
          "font-weight": "bold",
          "font-size": "30px",
          fill: "#43486a",
        });

      container
        .append("text")
        .attr("x", 0)
        .attr("y", 20)
        .attr("text-anchor", "middle")
        .text("شانس")
        .style({
          "font-weight": "bold",
          "font-size": "14px",
          fill: "#43486a",
        });

      var btnrotate = $("#avans_rotate_wheel");
      btnrotate.on("click", function () {
        $(this).prop("disabled", true);
        $(this).hide();
        $(".avans-spin-wheel-loading").show();
        $.ajax({
          url: avans_spin_wheel.ajax,
          dataType: "json",
          type: "post",
          data: {
            action: "avans_get_prize_spin_wheel",
            wheel_id: avans_spin_wheel.wheel_id,
          },
          success: function (data) {
            if (data.result.index > -1) {
              spin(data.result.index);
              setTimeout(function () {
                btnrotate.prop("disabled", false);
                $(".avans-spin-wheel-loading").hide();
                btnrotate.show();
                get_result_wheel(data.result.result);
                $(".number_chance").text($(".number_chance").text() - 1);
                if ($(".number_chance").text() <= 0) {
                  btnrotate.prop("disabled", true);
                }
              }, 10000);
            }
            if (data.result.error) {
              $(".avans-spin-wheel-loading").hide();
              btnrotate.show();
              btnrotate.prop("disabled", true);
              alert(data.result.msg);
            }
          },
        });

      });

      function get_result_wheel(response) {
        $.ajax({
          url: avans_spin_wheel.ajax,
          dataType: "html",
          type: "GET",
          data: {
            action: "avans_get_result_spin_wheel",
            response: response,
          },
          success: function (data) {
            $("#avans_result_spin_wheel").html(
              data.substr(data.length - 1, 1) === "0"
                ? data.substr(0, data.length - 1)
                : data
            );
          },
        });
      }
    
      function spin(item) {
        var ps = 360 / data.length,
          pieslice = Math.round(1440 / data.length),
          rng = Math.floor(Math.random() * 1440 + 10000);

        rotation = Math.round(rng / ps) * ps;

        picked = Math.round(data.length - (rotation % 360) / ps);
        picked = picked >= data.length ? picked % data.length : picked;

        // console.log(data[picked].value);
          if (data[picked].value !== item) {
            spin(item);
            return;
          }
        

        rotation += 90 - Math.round(ps / 2);
        vis
          .transition()
          .duration(10000)
          .attrTween("transform", rotTween)
          .each("end", function () {
            // d3.select("#question h1")
            //     .text(data[picked].question);
            oldrotation = rotation;
            return;
          });
      }

      function rotTween(to) {
        var i = d3.interpolate(oldrotation % 360, rotation);
        return function (t) {
          return "rotate(" + i(t) + ")";
        };
      }
    }
    new spinWhellRotate(avans_spin_wheel);
});
