<?php

use Avans\data;
use Avans\func;

$user_id    = get_current_user_id();
$time       = jdate('Y-m-d', time());
$last_visit = get_user_meta($user_id,AVANS_PREFIX.'last_visit', true);

if($time == $last_visit){
    return;
}

$option = [];
$option['score']      = (int)data::get_action_score('daily-visit', $user_id );
$option['delay']      = !empty($settings['delay']) ? (int)$settings['delay'] * 1000 : 1000;
$unit = func::get_score_label();
$option['text'] = 'شما بابت مشاهده سایت '.$option['score']." $unit گرفتید";
if (!empty($settings['text'])) {
    $option['text']  = str_replace("{score}", $option['score'], $settings['text']);
}

$data = array(
    'url' => admin_url('admin-ajax.php'),
    'plugin_uri' => AVANS_URI,
    'settings' => $option,
);

wp_localize_script("avans_score_daily_localize_script", "avs_set_score_daily_visit", $data);
wp_enqueue_script("avans_score_daily_localize_script");