<?php

use Avans\data;
use Avans\func;

$posts_viewed = (array)get_user_meta(get_current_user_id(),AVANS_PREFIX.'post_types_viewed',true);
$post_type = get_post_type(get_queried_object_id());

if( in_array($post_type,data::get_lms_postTypes_support()) ){
    $post_type = 'course';
}

$post_types_valid = ['post','page','product','course'];

if (!in_array(get_the_ID(), $posts_viewed) && in_array($post_type,$post_types_valid)) {

    $settings = (null !== AVANS_SETTINGS['score_settings'][$post_type]) ? AVANS_SETTINGS['score_settings'][$post_type] : [];
    $score = (int)data::get_action_score('view-'.$post_type,get_current_user_id());

    if($post_type == 'page'){
        $settings = (array)get_post_meta(get_the_ID(),AVANS_PREFIX.'meta_score_page',true);
        $score = isset($settings['score']) ? (int)$settings['score'] : 0;
    }

    if(empty($settings) || (isset($settings['active']) && !$settings['active']) || $score == 0 ){
        return;
    }

    $unit = func::get_score_label();

    $option = [
        'score' => (int)$score,
        'text' => !empty($settings['text']) ? $settings['text'] : " شما برای مشاهده این صفحه {score} $unit گرفتید ",
        'delay' => (int)$settings['delay'] * 1000,
    ];



    $data = array(
    'url' => admin_url('admin-ajax.php'),
    'plugin_uri' => AVANS_URI,
    'type' => $post_type,
    'id' => get_queried_object_id(),
    'user' => get_current_user_id(),
    'settings' => $option,
    );

    wp_localize_script("avans_score_post_localize_script", "avs_set_score_post_type", $data);
    wp_enqueue_script("avans_score_post_localize_script");

}