<?php

use Avans\data;
use Avans\func;
use Avans\user;

$price = data::get_total_order($order);
$items = $order->get_items();
$sum_score = 0;
$min_price = !empty($settings['min_price']) ? (int)$settings['min_price'] : 0 ;

if($settings['active'] && $order->get_payment_method() != 'wallet' && $price >= $min_price) {

    $sum_score = data::get_sum_score_for_purchase($user->ID,$order);
    $is_permision = user::is_permision_get_score('wc_order', $user->ID);
    $sum_score =  user::get_valid_score($user->ID, $sum_score,true);

    if($sum_score > 0 &&  $is_permision){

        $details = [
            array(
                'key' => 'order_id',
                'value' => $order_id,
            )
        ];
        
        user::add_log($user->ID,'wc_order',$details,$sum_score);
    }


    if($sum_score > 0  && $settings['status'] == 'after-purchase' && $is_permision ){

        $option = [];
        $unit = func::get_score_label();
        $option['text'] = 'شما بابت خرید از ما '.$sum_score." $unit گرفتید";
        if (!empty($settings['text'])) {
            $option['text']  = str_replace("{score}", $sum_score , $settings['text'] ); 
        }


        $data = array(
            'text' => $option['text'],
        );
        
        wp_localize_script("avans_score_order_localize_script", "avs_show_alert", $data);
        wp_enqueue_script("avans_score_order_localize_script");
    }


}