<?php
use Avans\data;
wp_enqueue_style('avans_select2');

$short = [
    'score' => isset($settings['score']) ?  $settings['score'] : '',
    'level' => isset($settings['level']) ?  $settings['level'] : '',
    'roles' => isset($settings['roles']) ?  $settings['roles'] : [],
    'badges' => isset($settings['badges']) ?  $settings['badges'] : [],
];
$shortcodes = "[avans-post-lock score='".$short['score']."'    level='".$short['level']."'  roles='".implode(',',(array)$short['roles'])."'   badges='".implode(',',(array)$short['badges'])."'  ]محتوای شما[/avans-post-lock]";

$permision_roles = [];
if(isset($settings['roles'])){
    foreach ((array)$settings['roles'] as $role) {
        $item = [
            'id' => $role,
            'name' => translate_user_role($role),
        ];
        $permision_roles[] = $item; 
    }
}

$permision_badges = [];
if(isset($settings['badges'])){
    foreach ((array)$settings['badges'] as $badge) {
        $item = [
            'id' => $badge,
            'name' => get_the_title((int)$badge),
        ];
        $permision_badges[] = $item;
    }
}

?>


<div class="wrap avans_components">
    <table class="form-table">

        <tr valign="top">
            <th scope="row">فعال سازی قفل صفحه</th>
            <td>
                <input type="checkbox" name="avans_pageLock_is_active" value="active" <?php echo (isset($settings['active']) && $settings['active']) ? 'checked' : ''; ?>>
                <label>فعال یا غیرفعال </label>          
            </td>
        </tr>

        <tr valign="top">
            <th scope="row">حداقل امتیاز لازم برای باز شدن قفل</th>
            <td><input type="number" value="<?php echo !empty($settings['score']) ? $settings['score'] : ''; ?>" name="avans_pageLock_score" placeholder="مثلا 5"><span> امتیاز </span></td>
        </tr>

        <tr valign="top">
            <th scope="row">حداقل سطح کاربری لازم برای باز شدن قفل</th>
            <td>
                <select id="avans_select_user_level_for_open_lock" name="avans_select_user_level_for_open_lock">
                    <option value="unset">:: انتخاب سطح کاربری ::</option>
                    <?php 
                    $data = get_option('avans_plugin_setting', []);
                    foreach ((array)$data['avans_user_levels'] as $level) :
                    ?>
                        <option value="<?php echo $level['level'] ?>" <?php  echo (isset($settings['level']) && $settings['level'] == $level['level']) ? ' selected' : ''   ?>><?php echo $level['level'] ?></option>
                    <?php
                    endforeach;
                    ?>
                </select>
            </td>
        </tr>

        <tr valign="top">
            <th scope="row">نقش کاربری لازم برای باز شدن قفل</th>
            <td>
                <select data-avans="<?php echo htmlspecialchars(json_encode($permision_roles), ENT_QUOTES, 'UTF-8') ?>" multiple id="avans_select_user_roles_for_open_lock"  name="avans_select_user_roles_for_open_lock[]">
                    <option>:: انتخاب نقش ::</option>
                        <?php 
                            global $wp_roles;
                            $roles = apply_filters('editable_roles', $wp_roles->roles);
                            foreach ($roles as $index=>$rol) {
                                ?>
                                <option value="<?php echo $index ?>" ><?php echo translate_user_role($rol['name']) ?></option>
                                <?php
                            }
                        ?>
                </select>
            </td>
        </tr>

        <tr valign="top">
            <th scope="row" >نشان لازم برای باز شدن قفل</th>
            <td>
                <?php $badges = data::get_badges(array());?>
                <select data-avans="<?php echo htmlspecialchars(json_encode($permision_badges), ENT_QUOTES, 'UTF-8') ?>"  multiple id="avans_select_user_badges_for_open_lock" name="avans_select_user_badges_for_open_lock[]">
                    <option>::انتخاب نشان::</option>
                    <?php 
                        foreach($badges->posts as $badge){
                            ?>
                                <option value="<?php echo $badge->ID ?>"><?php echo get_the_title($badge->ID) ?></option>
                            <?php
                        }
                    ?>
                </select>
            </td>
        </tr>

        <tr valign="top">
            <th scope="row" >کد کوتاه درون متنی (inline)</th>
            <td>شما می توانید با استفاده از کد کوتاه زیر بخش دلخواهی از محتوای صفحه را محدود به کاربران خاصی کنید ( اگر از حالت کد کوتاه استفاده می کنید ، حتما گزینه قفل صفحه رو غیرفعال کنید،چون به صورت همزمان نمی توان از هر دو حالت استفاده کرد. )</td>
        </tr>

        <tr valign="top">
            <th scope="row" ></th>
            <td>
                <div id="avans_constructor_shortcode_lockpage"><?php echo $shortcodes ?></div>
            </td>
        </tr>

    </table>
        
    </div>

<?php
$data = [];
wp_localize_script('avans_lock_post_settings_localize_script','data_lock_post',$data);
wp_enqueue_script('avans_lock_post_settings_localize_script');
wp_enqueue_script('avans_select2');


