<?php
use Avans\data;
?>
<div class="settings avans-component">
    <div class="slice_list">
    <div class="section_field_spin_wheel">
        <div class="spend_score_type settings-type" >
            <div class="avans_row_wrapper_field">
                <div class="title_label">امتیاز لازم برای هر بار چرخاندن گردونه شانس</div>
                <input type="number" name="avans_spin_wheel_score" value="<?php echo isset($settings['score']) ? $settings['score'] : '' ?>"><span>امتیاز</span>
            </div>

        </div>

        <div class="select_type_use_from_spin_wheel avans_row_wrapper_field">
            <div class="title_label">گردوندن رایگان در بازه های زمانی</div>
            <label class="switch">
                <input type="checkbox" class="is_active_free_spin" name="is_active_free_spin" <?php echo ( isset($settings['is_active_free_spin']) && $settings['is_active_free_spin'] ) ? 'checked' : '' ?> >
                <span class="slider round"></span>
                <span class="label">فعال/غیرفعال</span>
            </label>   
        </div>

        <div class="free_in_durationtime_time settings-type"  style="display: <?php echo (isset($settings['is_active_free_spin']) && $settings['is_active_free_spin']) ? 'block' : 'none' ?>;">

            <div class="avans_row_wrapper_field">   
                <div class="title_label">بازه زمانی</div>
                <input type="number" name="avans_spin_wheel_duration_value" class="avans_spin_wheel_duration_value" value="<?php echo (isset($settings['duration']['value'])) ? $settings['duration']['value'] : "" ?>">
                <select name="avans_spin_wheel_duration_unit" class="avans_spin_wheel_duration_unit"> 
                    <option value="hour" <?php echo (!isset($settings['duration']['unit']) || $settings['duration']['unit'] == "hour") ? "selected" : "" ?> >ساعت</option>
                    <option value="day" <?php echo ( isset($settings['duration']['unit']) && $settings['duration']['unit'] == "day") ? "selected" : "" ?> >روز</option>
                    <option value="week" <?php echo ( isset($settings['duration']['unit'])  && $settings['duration']['unit'] == "week") ? "selected" : "" ?> >هفته</option>
                    <option value="month" <?php echo ( isset($settings['duration']['unit'])  && $settings['duration']['unit'] == "month") ? "selected" : "" ?> >ماه</option>
                    <option value="year" <?php echo ( isset($settings['duration']['unit']) && $settings['duration']['unit'] == "year") ? "selected" : "" ?> >سال</option>
                </select>
            </div>

            <p class="description_duration_method">
                <span class="dashicons dashicons-info-outline"></span>
                <span> با این تنظیم کاربران شما می توانند هر </span>
                    <span class="value"><?php echo isset( $settings['duration']['value'] ) ?   $settings['duration']['value']  : 0  ?></span>
                    <span class="unit">
                        <?php echo isset( $settings['duration']['unit'] ) ? data::get_string_time($settings['duration']['unit']) : 'ساعت'; ?>
                    </span>
                <span> یکبار گردونه شانس را بدون کسر امتیاز بچرخانند.</span>
                <span>طبیعتا بعد از استفاده از حالت رایگان دفعات بعدی طبق تنظیمات اعمال خواهد شد و کسر امتیاز صورت میگیرد.</span>
            </p>
        </div>


    </div>
    <div class="">قسمت ها</div>
    <hr>
    <?php if(isset($settings['slices'])): ?>
        <?php foreach((object)$settings['slices'] as $slice): ?>
        <div class="slice">
            <div class="header">
                <div class="operation">
                    <span class="dashicons dashicons-plus-alt2 add"></span>
                    <span class="dashicons dashicons-minus remove"></span>
                </div>
                <div class="title_chance"><?php echo $slice->title ?></div> 
                <span class="dashicons dashicons-arrow-up-alt2 collapse"></span>
            </div>
            <div class="settings_slice_wrapper">
                <div class="row-1">
                    <div class="label">
                        <div class="title">نوع</div>
                        <select class="avans_type_gift" class="type">
                            <option value="coupon" <?php echo $slice->type == 'coupon' ? 'selected' : '' ?> >کد تخفیف یکبارمصرف</option>
                            <option value="product" <?php echo $slice->type == 'product' ? 'selected' : '' ?> >محصول</option>
                            <option value="file" <?php echo $slice->type == 'file' ? 'selected' : '' ?> >فایل</option>
                            <option value="score" <?php echo $slice->type == 'score' ? 'selected' : '' ?> >امتیاز</option>
                            <option value="zero" <?php echo $slice->type == 'zero' ? 'selected' : '' ?> >پوچ</option>
                        </select>
                    </div>
                    <div class="label">
                        <div class="title">عنوان</div>
                        <input class="title_chance" type="text" placeholder="عنوان" value="<?php echo $slice->title;?>">
                    </div>
                    <div class="label">
                        <div class="title">تعداد موجودی</div>
                        <input class="stock_chance" type="number" placeholder="موجودی" value="<?php echo $slice->stock;?>">
                    </div>
                    <div class="label">
                        <div class="title">احتمال (درصد)</div>
                        <input class="possiblity_chance" type="number" placeholder="احتمال" value="<?php echo $slice->possibility;?>">
                    </div>
                    <div class="label">
                        <div class="title">رنگ پس زمینه بخش</div>
                        <input  type="text" class="background_slice" type="text" placeholder="#aaa" value="<?php echo $slice->background;?>">
                    </div>
                    <div class="label">
                        <div class="title">رنگ متن بخش</div>
                        <input type="text" class="color_text_slice" placeholder="#eee" value="<?php echo $slice->color;?>">
                    </div>
                </div>
            <?php  switch($slice->type) { 
                case 'coupon':
                    include AVANS_PATH.'templates/admin/metaboxes/parts/spin-wheel/coupon.php';
                break;
                case 'file':
                    include AVANS_PATH.'templates/admin/metaboxes/parts/spin-wheel/file.php';
                break;
                case 'product':
                    include AVANS_PATH.'templates/admin/metaboxes/parts/spin-wheel/product.php';
                break;
                case 'score':
                    include AVANS_PATH.'templates/admin/metaboxes/parts/spin-wheel/score.php';
                break;
             }?>
            </div>
        </div>
        <?php endforeach; ?>
    <?php endif; ?>
    </div>
    <button id="add_slice_to_spin_wheel" class="button">افزودن جایزه</button>
    <input id="avans_spin_wheel_settings_all" name="avans_spin_wheel_settings_all" type="hidden">
</div>
<?php  include AVANS_PATH.'templates/admin/metaboxes/parts/spin-wheel/load-scripts.php'; ?>