<?php
    use Avans\data;

    $limited_custom_product_for_copon = [];
    foreach ((array)$slice->limit_products as $product) {
        $product = wc_get_product($product);
        if(is_object($product)){
            if ($product->get_type() == 'variation') {
                $prTitle= str_replace('<span class="description">', '', $product->get_formatted_name());
                $prTitle= str_replace('</span>', '', $prTitle);
                $item = [
                    'id' => $product->get_ID(),
                    'name' => $prTitle,
                ];
            } else {
                $item = [
                    'id' => $product->get_ID(),
                    'name' => get_the_title($product->get_ID()),
                ];
            }
            $limited_custom_product_for_copon[] = $item;
        }
    }


    $exclude_custom_product_for_copon = [];
    foreach ((array)$slice->exclude_products as $product) {
        $product = wc_get_product($product);
        if(is_object($product)){
            if ($product->get_type() == 'variation') {
                $prTitle= str_replace('<span class="description">', '', $product->get_formatted_name());
                $prTitle= str_replace('</span>', '', $prTitle);
                $item = [
                    'id' => $product->get_ID(),
                    'name' => $prTitle,
                ];
            } else {
                $item = [
                    'id' => $product->get_ID(),
                    'name' => get_the_title($product->get_ID()),
                ];
            }
            $exclude_custom_product_for_copon[] = $item;
        }
    }


    $limited_custom_category_for_copon = [];
    foreach ((array)$slice->limit_categorys as $cat) {
        $term_title = get_term($cat, 'product_cat');
        $item = [
            'id' => $cat,
            'name' => $term_title->name,
        ];
        $limited_custom_category_for_copon[] = $item;
    }

    $exclude_custom_category_for_copon = [];
    foreach ((array)$slice->exclude_categorys as $cat) {
        $term_title = get_term($cat, 'product_cat');
        $item = [
            'id' => $cat,
            'name' => $term_title->name,
        ];
        $exclude_custom_category_for_copon[] = $item;
    }

?>
<table class="form-table item" id="coupon-options">
    <tr valign="top">
        <th scope="row">نوع کد تخفیف</th>
        <td>
            <select class="avans_type_coupon_gift">
                <option value="percent" <?php echo empty($slice->type_coupon) || $slice->type_coupon == 'percent' ? 'selected' : '' ?> >درصدی</option>
                <option value="static" <?php echo empty($slice->type_coupon) || $slice->type_coupon == 'static' ? 'selected' : '' ?> >ثابت</option>
            </select>
        </td>
    </tr>
    <tr valign="top">
        <th scope="row">تعداد کارکتر های کدتخفیف</th>
        <td>
        <input type="number" class="number_of_charecter_coupen" value="<?php echo $slice->char_coupon  ?>">
            <label>کارکتر</label>
        </td>
    </tr>
    <tr valign="top">
        <th scope="row">اعتبار زمانی کد تخفیف</th>
        <td>
        <input type="number" class="expire_date_coupen" value="<?php echo $slice->expire_coupon ?>">
        <label>روز بعد از ایجاد کد</label>
        </td>
    </tr>
    <tr valign="top">
        <th scope="row">میزان کد تخفیف</th>
        <td>
            <input type="number" class="value_percent_coupen" value="<?php echo $slice->coupon_value ?>">
            <label class="label_coupon_value_type"></label>
        </td>
    </tr>


    <tr valign="top">
        <th>تنظیمات پیشرفته</th>
        <td><hr></hr></td>
    </tr>

    <tr valign="top">
        <th scope="row">سقف اعمال کد تخفیف</th>
        <td>
        <input type="number" class="max_discount_coupon" name="max_discount_coupon" value="<?php echo $slice->max_discount ?>">
        <span><?php echo Avans\data::get_payment_unit(); ?></span>
        </td>
    </tr>
    
    <tr valign="top">
        <th scope="row">پیشوند کد تخفیف</th>
        <td>
            <input type="text" class="prefix_coupen" name="prefix_coupen" value="<?php echo $slice->prefix; ?>">
        </td>
    </tr>

    
    <tr valign="top">
        <th scope="row">به‌جز محصولات فروش ویژه</th>
        <td>
            <label class="switchi">
                <input type="checkbox" class="exclude_sale_product" <?php echo $slice->exclude_sale_product  == 'true' ? 'checked' : '' ?> >
                <span class="slideri roundi"></span>
                <span class="label">فعال/غیرفعال</span>
            </label>
            <p>اگر نمی خواهید کد تخفیف برای محصولات تخفیف خورده استفاده شود، این بخش را فعال کنید</p>
        </td>
    </tr>


</table>

<div class="item coupon-options">
    <div class="avans_accordion_box">
        <div class="accordion_title"><span>تعیین حداقل و حداکثر مبلغ سبد خرید برای اعمال کد</span><span class="dashicons dashicons-arrow-down-alt2"></span></div>
        <div class="accordion_wrapper">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">حداقل مبلغ سبد خرید برای اعمال کد</th>
                    <td>
                    <input type="number" class="min_price_for_coupen" name="min_price_for_coupen" value="<?php echo $slice->min_price  ?>">
                    <span><?php echo data::get_payment_unit() ?></span>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">حداکثر مبلغ سبد خرید برای اعمال کد</th>
                    <td>
                    <input type="number" class="max_price_for_coupen" name="max_price_for_coupen" value="<?php echo $slice->max_price ?>">
                    <span><?php echo data::get_payment_unit() ?></span>
                    </td>
                </tr>
            </table>
        </div>
    </div>
    <div class="avans_accordion_box">
        <div class="accordion_title"><span>محدود کردن اعمال کد برای دسته بندی ها و محصولات خاص</span><span class="dashicons dashicons-arrow-down-alt2"></span></div>
        <div class="accordion_wrapper">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">اعمال بر محصولات خاص</th>
                    <td>
                        <label class="user">
                            <select class="limited_custom_product_for_copon" name="limited_custom_product_for_copon[]" data-avans="<?php echo htmlspecialchars(json_encode($limited_custom_product_for_copon), ENT_QUOTES, 'UTF-8') ?>"  data-placeholder="جستجو در بین محصولات..." multiple="multiple"></select>
                        </label>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">اعمال بر دسته بندی های خاص</th>
                    <td>
                    <label class="user">
                        <select class="limited_custom_category_for_copon" name="limited_custom_category_for_copon[]" data-avans="<?php echo htmlspecialchars(json_encode($limited_custom_category_for_copon), ENT_QUOTES, 'UTF-8') ?>" data-placeholder="جستجو در بین دسته بندی ها..." multiple="multiple"></select>
                    </label>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">اعمال بجزء محصولات خاص</th>
                    <td>
                        <label class="user">
                            <select class="exclude_custom_product_for_copon" name="exclude_custom_product_for_copon[]" data-avans="<?php echo htmlspecialchars(json_encode($exclude_custom_product_for_copon), ENT_QUOTES, 'UTF-8') ?>"  data-placeholder="جستجو در بین محصولات..." multiple="multiple"></select>
                        </label>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">اعمال بجزء دسته بندی خاص</th>
                    <td>
                    <label class="user">
                        <select class="exclude_custom_category_for_copon" name="exclude_custom_category_for_copon[]" data-avans="<?php echo htmlspecialchars(json_encode($exclude_custom_category_for_copon), ENT_QUOTES, 'UTF-8') ?>" data-placeholder="جستجو در بین دسته بندی ها..." multiple="multiple"></select>
                    </label>
                    </td>
                </tr>
            </table>
        </div>
    </div>
</div>