
<?php

use Avans\data;

wp_enqueue_style('avans_select2');
?>

<label class="user">
    <span class="label">فیلتر کاربر</span>
    <select class="avans_search_user_select" data-placeholder="جستجو در بین کاربر ها..."></select>
</label>

<label class="gifts">
    <span class="label">فیلتر جوایز</span>
    <select class="avans_search_gifts_list" data-placeholder="جستجو در بین هدایا...">
        <option value="0">همه جوایز</option>
        <?php echo "<optgroup label='کدهای تخفیف'>"; ?>
        <option value="-1">کد تخفیف بعد از خرید</option>
        <option value="-2">کد تخفیف سالگرد تولد</option>
        <option value="-3">کد تخفیف سالگرد عضویت</option>
        <option value="-4">کد تخفیف بعد از ثبت نام</option>
        <option value="-5">کد تخفیف بعد از قراردادن دیدگاه مشتری</option>
        <?php echo "</optgroup>"; ?>

        <?php
        $gifts = data::get_gifts();
        if($gifts->posts): 
            echo "<optgroup label='جوایز'>";
            foreach($gifts->posts as $gift): 
            ?><option value="<?php echo $gift->ID ?>"><?php echo get_the_title($gift->ID); ?></option><?php 
            endforeach;
            echo "</optgroup>";
        endif; ?>

        <?php
        $spinWheel = data::get_spinwheels();
        if($spinWheel->posts): 
            echo "<optgroup label='گردونه های شانس'>";
            foreach($spinWheel->posts as $spinWheel): 
            ?><option value="<?php echo $spinWheel->ID ?>"><?php echo get_the_title($spinWheel->ID); ?></option><?php 
            endforeach;
            echo "</optgroup>";
        endif; ?>

    </select>
</label>

<label class="date">
    <span class="label">فیلتر تاریخ شروع گزارش</span>
    <input type="text" id="filter_time1" class="avans_persian_date_picker"  placeholder="از تاریخ..." >
</label>

<label class="date">
    <span class="label">فیلتر تاریخ پایان گزارش</span>
    <input type="text" id="filter_time2" class="avans_persian_date_picker" placeholder="تا تاریخ...">
</label class="label">

<label class="btn-filter">
    <button id="avans-btn-filter-log" class="button">فیلتر کن!</button>
</label>

<script>
    jQuery(document).ready(function($){
        $(".avans_search_gifts_list").select2();
        $('#checkselect2').select2();
        $('.avans_search_user_select').change(function(){
            console.log($(this).val());
        });


        $('.avans_search_user_select').select2({
            ajax: {
                    url: '<?php echo admin_url('admin-ajax.php') ?>', // AJAX URL is predefined in WordPress admin
                    dataType: 'json',
                    delay: 250, 
                    data: function (params) {
                        return {
                            q: params.term,
                            action: 'avans_serach_user'
                        };
                    },
                    processResults: function( data ) {
                        var options = [];
                        if ( data ) {

                            // data is the array of arrays, and each of them contains ID and the Label of the option
                            $.each( data, function( index, text ) { // do not forget that "index" is just auto incremented value
                                options.push( { id: text[0], text: text[1]  } );
                            });

                        }
                        return {
                            results: options
                        }
                    },
                cache: true
            },
            allowClear: true,
            minimumInputLength: 3,
            language: {
                inputTooShort: function () {
                    return "حداقل سه حرف از نام کاربری ، نام نمایشی یا ایمیل کاربر وارد نمایید...";
                },
                searching: function() {
                    return "در حال جستجو...";
                }
            }
        });
        var customOptions = {
			twodigit: false
			, closeAfterSelect: true
            // , nextButtonIcon : 'dashicons dashicons-arrow-left-alt2'
            // , previousButtonIcon : 'dashicons dashicons-arrow-right-alt2'
			// , buttonsColor: "blue"
			, forceFarsiDigits: true
			, markToday: true
			// , markHolidays: true
			, highlightSelectedDay: true
			, sync: true
			// , gotoToday: true
		}

        $("#avans-btn-filter-log").on('click', function (e) {
        e.preventDefault();
        // console.log(search);
            var data = {
                gift : $(this).closest(".header").find(".avans_search_gifts_list").val(),
                from: $(this).closest(".header").find("#filter_time1").val(),
                to : $(this).closest(".header").find("#filter_time2").val(),
                user : $(this).closest(".header").find(".avans_search_user_select").val(),
                page : 1,
            }
            search_logs(data);
        });

        $(document).on('click','a.page-numbers',function(e){
            e.preventDefault();
            var href = $(this).attr('href');
            var number = $(this).attr('href').split('cpage=');
            var data = {
                gift : $('#avans-btn-filter-log').closest(".header").find(".avans_search_gifts_list").val(),
                from: $('#avans-btn-filter-log').closest(".header").find("#filter_time1").val(),
                to : $('#avans-btn-filter-log').closest(".header").find("#filter_time2").val(),
                user : $('#avans-btn-filter-log').closest(".header").find(".avans_search_user_select").val(),
                page : number[1],
            }
            search_logs(data);
        });

        function search_logs(data){
            // console.log(data);
            $('.avans_gifts_log_wrapper')
            .append(
                '<div class="avans-loader"><div class="lds-ripple"><div></div><div></div></div></div>'
            );
            $.ajax({
                url : '<?php echo admin_url('admin-ajax.php') ?>',
                dataType : 'html',
                type: "GET",
                data : {
                    action : 'avans_search_gifts_logs',
                    gift : data.gift,
                    from: data.from,
                    to : data.to,
                    user : data.user,
                    page : data.page,
                },
                success:function(data){
                    // console.log(data);
                    $('.avans_gifts_log_wrapper>.content').html(data);
                    $('.avans-loader').remove();
                }
            });
        }

    });
</script>

<?php
wp_enqueue_script('avans_select2');