<?php

use Avans\func;
use Avans\parts\completeProfile;
use Avans\user;

function avans_complete_user_info_shortcode_callback()
{
    ob_start();

    if (get_current_user_id() == 0) {
        echo "<div class='avans-message'>برای مشاهده این بخش باید وارد شوید</div>";
        return ob_get_clean();
    }

    $user_id = get_current_user_id();
    $data = user::get_user_info($user_id);
    $is_send_sms = completeProfile::is_send_validation($user_id, 'mobile');
    $is_send_email = completeProfile::is_send_validation($user_id, 'email');
    $settings = AVANS_SETTINGS['panel_settings']['user_complete']; ?>
        <div class="title_user_info">
            <h3>تکمیل اطلاعات کاربری</h3>
        </div>
        <form id="avans_complete_user_info_form" method="post" enctype="multipart/form-data" style="<?php echo $is_send_email || $is_send_email ? 'display:none;' : '' ?>">
            <div class="avans_wrapper_input_fields">

                <?php if (!func::is_set($settings['show_name']) || $settings['show_name'] == 'true'): ?>
                    <div class="avans_wrapper_field">
                        <label for="avans_user_name">نام</label>
                        <input class="avans_user_info" data-type="firstname" id="avans_user_firstname" name="avans_user_firstname" type="text" value="<?php echo $data->firstname ?>">
                    </div>
                <?php endif; ?>

                <?php if (!func::is_set($settings['show_last_name']) || $settings['show_last_name'] == 'true'): ?>
                    <div class="avans_wrapper_field">
                        <label for="avans_user_lastname">نام خانوادگی</label>
                        <input class="avans_user_info" data-type="lastname" id="avans_user_lastname" name="avans_user_lastname"  type="text" value="<?php echo $data->lastname ?>";>
                    </div>
                <?php endif; ?>

                <?php if (!func::is_set($settings['show_birthdate']) || $settings['show_birthdate'] == 'true'): ?>
                    <div class="avans_wrapper_field">
                        <label for="avans_user_birthday">تاریخ تولد</label>
                        <input class="avans_user_info avans_persian_date_picker" data-type="birthdate" id="avans_user_birthdate" name="avans_user_birthdate" type="text" value="<?php echo func::is_set($data->birhdate) ? $data->birhdate : '' ?>";>
                    </div>
                <?php endif; ?>

                <?php if (!func::is_set($settings['show_mobile']) || $settings['show_mobile'] == 'true'): ?>
                    <div class="avans_wrapper_field">
                        <label for="avans_user_mobile">شماره موبایل</label>
                        <input class="avans_user_info" data-type="mobile" id="avans_user_mobile" name="avans_user_mobile" type="text" value="<?php echo $data->mobile ?>" >  
                    </div>
                <?php endif; ?>

                <?php if (!func::is_set($settings['show_email']) || $settings['show_email'] == 'true'): ?>
                    <div class="avans_wrapper_field">
                        <label for="avans_user_name">ایمیل</label>
                        <input class="avans_user_info" data-type="email" id="avans_user_email" name="avans_user_email" type="text" value="<?php echo $data->email ?>">
                    </div> 
                <?php endif; ?>

            </div>
            <?php if (!func::is_set($settings['show_avatar']) || $settings['show_avatar'] == 'true'): ?>
                <div class="avans_wrapper_field avatar">
                    <!-- <label>تصویر پروفایل کاربری</label> -->
                    <img id="avans_avatar_image" src="<?php echo $data->avatar ?>" width="90">
                    <button id="avans_btn_change_avatar">تغییر تصویر</button>
                    <input style="display: none;" class="avans_user_info" type="file" data-type="avatar" id="avans_user_avatar" name="avans_user_avatar">
                    <input class="avans_user_info" data-type="last_avatar" id="avans_user_avatar_url" name="avans_user_avatar_url" type="hidden" value="<?php echo $data->avatar ?>" >
                </div>
            <?php endif; ?>

            <input type="submit" class="avans-button normal" value="تایید اطلاعات کاربری" id="avans_submit_user_info" data-ajax="<?php echo admin_url('admin-ajax.php') ?>">
            <button class="avans-button outline" id="avans_return_to_check_opt" style="display: none;">بازگشت به تایید اعتبار</button>

        </form>

        <div id="avans_complete_user_check_validate_code" data-ajax="<?php echo admin_url('admin-ajax.php') ?>" style="<?php echo $is_send_email || $is_send_email ? '' : 'display:none;' ?>" >

            <div class="avans_wrapper_field confirm_email" style="<?php echo $is_send_email ? '' : 'display: none;' ?>">
                <label for="avans_user_confirm_email">کد تایید ایمیل</label>
                <p class="avans_description">یک ایمیل حاوی کد تایید ، به حساب ایمیلی که در فرم تکمیل اطلاعات پرکردید ارسال شد.لطفا کد تایید را در اینجا وارد نمایید.</p>
                <div class="avans_flex_wrapper">
                    <input class="avans_user_info" data-type="confirm_email" id="avans_user_confirm_email"  type="text" ;>
                    <button class="avans-button outline confirm" data-type="email">تایید</button>
                    <button class="avans-button outline resend" data-type="email">ارسال مجدد</button>
                </div>
            </div>

            <div class="avans_wrapper_field confirm_mobile" style="<?php echo $is_send_sms ? '' : 'display: none;' ?>">
                <label for="avans_user_confirm_mobile">کد تایید شماره موبایل</label>
                <p class="avans_description">یک پیامک حاوی کد تایید ، به شماره موبایلی که در فرم تکمیل اطلاعات پرکردید ارسال شد.لطفا کد تایید را در اینجا وارد نمایید.</p>
                <div class="avans_flex_wrapper">
                    <input class="avans_user_info" data-type="confirm_mobile" id="avans_user_confirm_mobile"  type="text" ;>
                    <button class="avans-button outline confirm" data-type="mobile">تایید</button>
                    <button class="avans-button outline resend" data-type="mobile">ارسال مجدد</button>
                </div>
            </div>

            <button class="avans-button outline" id="avans_return_to_edit_data">بازگشت به ویرایش پروفایل</button>
        </div>
    <?php
    include_once AVANS_PATH.'templates/generals/popup-date-picker.php';
    return ob_get_clean();
}
add_shortcode('avans-complete-user-info', 'avans_complete_user_info_shortcode_callback');
