<?php

use Avans as GlobalAvans;
use Avans\avans;
use Avans\user;
use Avans\data;
use Avans\func;

function avans_convert_wallet_shortcode_callback(){
    ob_start();

    if (get_current_user_id() == 0) {
        echo "<div class='avans-message'>".sprintf(__("برای مشاهده فرم تبدیل %s به اعتبار کیف پول باید وارد شوید."),func::get_score_label())."</div>";
        return ob_get_clean();
    }

    $permision = user::is_permision_convert_wallet(get_current_user_id());?>
    <div class="avans-convert-score">

        <?php if (!$permision): ?>
            <div class="avans_messege warning"><?php echo data::get_description_permision_convert() ?></div>
        <?php endif; ?>

        <?php if (is_int($permision)): ?>
            <div class="avans_messege warning"><?php echo sprintf(__("برای تبدیل %s به اعتبار کیف پول حداقل به %s %s بیشتر احتیاج دارید"),func::get_score_label(true), $permision,func::get_score_label()) ?></div>
        <?php endif; ?>

        <form id="avans_show_convert_form" action="" method="post">
            <div class="avans_wrapper_convert_icon">
                <div class="score_box">
                    <?php echo func::get_score_icon(50); ?>
                    <p><span class="value"><?php echo user::get_score_valid(get_current_user_id()) ?></span><span class="unit"><?php echo func::get_score_label() ?></span></p>
                </div>
                <div class="equal_icon_box">
                    <p>معادل</p>
                    <i class="avans-ic avs-icon-exchange"></i>
                </div>
                <div class="wallet_box">
                    <i class="avans-ic avs-icon-wallet"></i>
                    <p><span class="value"><?php echo number_format(user::get_wallet_amount(get_current_user_id())) ?></span><span class="unit"><?php echo data::get_payment_unit() ?> </span></p>
                </div>
            </div>
            <div class="description"></div>
            <button <?php echo !$permision || is_int($permision) ? 'disabled' : '' ?> class="avans-button normal" id="avans_convert_btn" data-ajax="<?php echo admin_url('admin-ajax.php'); ?>"><i class="avans-ic avs-icon-exchange-alt"></i><?php echo sprintf(__("تبدیل %s به اعتبار کیف پول"),func::get_score_label()) ?></button>
        </form>
    </div>
    <?php
    return ob_get_clean();
}
add_shortcode('avans-convert-wallet','avans_convert_wallet_shortcode_callback');
add_shortcode('score-wallet','avans_convert_wallet_shortcode_callback');