<?php

use Avans\data;
use Avans\func;

function avans_user_list_shortcode_callback($atts){
    extract(shortcode_atts(array('type'=> 'classic','action' => 'all','period' => 'all','number' => 3,'col'=>1), $atts));
    ob_start();

    $args = [];
    $args['per_page'] = $number;
    if( isset($period) && in_array($period,array('daily','weekly','monthly','seasonal','yearly')) ){
        $args['time']['from'] = func::get_from_DBdate_by_string($period);
        $args['where'] = true;
    }

    if( isset($action) && in_array($action,data::get_list_actions()) ){
        $args['type']  = $action;
        $args['where'] = true;
    }

    if($type == 'classic'):
        $lists = data::get_users($args)['result'];
        ?>
        <div class="avans_wrapper_user_list <?php echo $type ?>">
            <div class="header">
                <div class="col rank">رتبه</div>
                <div class="col user">کاربر</div>
                <div class="col score"><?php echo Avans\func::get_score_label(); ?></div>
            </div>
            <div class="body">
               <?php  include AVANS_PATH.'templates/front/parts/user-simple-list.php';  ?>
            </div>
        </div>
        <?php
    endif;

    if($type == 'columnar'): ?>
        <div class="avans_wrapper_user_list <?php echo $type ?>">
            <div class="body">
                <?php for($i = 1; $i <= $col; $i++): ?>
                    <?php 
                    $args['page'] = $i;
                    $lists = data::get_users($args)['result']; 
                    ?>
                    <div class="avans-col-users" style="flex-basis: calc(100% / <?php echo $col ?> - 16px);">
                        <?php  include AVANS_PATH.'templates/front/parts/user-simple-list.php';  ?>
                    </div>
                <?php endfor; ?>
            </div>
        </div>
        <?php
    endif;

    if ($type == 'carousel'):  ?>
        <div class="avans_wrapper_user_list <?php echo $type ?>" >
            <div class="body owl-carousel" data-col="<?php echo $col ?>">
                <?php $lists = data::get_users($args)['result']; ?>
                <?php  include AVANS_PATH.'templates/front/parts/user-simple-list.php';  ?>
            </div>
        </div>
        <?php
    endif;

    return ob_get_clean();
}
add_shortcode('avans-user-list','avans_user_list_shortcode_callback');
add_shortcode('score-list-user', 'avans_user_list_shortcode_callback');